package com.njcn.energy.controller;

import com.njcn.common.pojo.annotation.OperateInfo;
import com.njcn.common.pojo.enums.common.LogEnum;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.HttpResultUtil;
import com.njcn.common.utils.LogUtil;
import com.njcn.energy.pojo.po.EleEpdPqd;
import com.njcn.energy.pojo.po.EleSts;
import com.njcn.energy.service.IEleStsService;
import com.njcn.web.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/3/15 19:06
 */
@Slf4j
@RestController
@RequestMapping("/sts")
@RequiredArgsConstructor
@Api(tags = "设备状态数据管理")
public class EleStsController extends BaseController {

    private final IEleStsService eleStsService;

    @PostMapping("/add")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("新增电能质量数据")
    @ApiImplicitParam(name = "eleSts", value = "电能质量数据", required = true)
    public HttpResult<Boolean> add(@RequestBody EleSts eleSts){
        String methodDescribe = getMethodDescribe("add");
        LogUtil.njcnDebug(log, "{}，电能质量数据为：{}", methodDescribe, eleSts);
        boolean result = eleStsService.addSts(eleSts);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @PutMapping("/update")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("修改电能质量数据")
    @ApiImplicitParam(name = "eleSts", value = "电能质量数据", required = true)
    public HttpResult<Boolean> update(@RequestBody EleSts eleSts){
        String methodDescribe = getMethodDescribe("update");
        LogUtil.njcnDebug(log, "{}，电能质量数据为：{}", methodDescribe, eleSts);
        boolean result = eleStsService.updateSts(eleSts);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @GetMapping("/findByName")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("根据名称查找数据")
    @ApiImplicitParam(name = "name", value = "名称", required = true)
    public HttpResult<EleSts> findByName(@RequestParam String name){
        String methodDescribe = getMethodDescribe("findByName");
        LogUtil.njcnDebug(log, "{}，名称为：{}", methodDescribe, name);
        EleSts eleSts = eleStsService.findByName(name);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, eleSts, methodDescribe);
    }








}
